* FIXOB
*
* In  : any object
* Out : embedded object if argument was a string starting with "HPHP4",
*       and if the object itself is valid, else unchanged
*
* This program can be used to remove the binary header from an object, as often
* happens when downloading an object between calculators.
*
* check #E05Ah (48)
*       #3F75h (49)
* bytes 124.5
*
* This program will change an object of the form:
*
*      5     5     16      x   y
*     DOSTR lllll HPHP4.-. ob slack
* to
*      5     x     5    5     y+6  5
*     DOLIST ob DOHSTR length ... SEMI
*
* and will do so in-place, so that the string is not limited to half the available memory.
* This means that all references to the original object will point to a list.
*
* The actual tests performed:
* .string dispatch
* .string starts with "HPHP4"?
* .is there an embedded object (prologue check)
* .can it be skipped?
* .is it not too large ie is it contained in the original string?
*
* Werner Huysegoms 20000920
::
  CK1NoBlame
  CK&DISPATCH0
  str
  CODE
    GOSBVL =SAVPTR
    { A=DAT1.A D0=A D1=A		% pointer to object

      D0+5 A=DAT0.A			% length field
      CD0EX D0=C R0=C.W			% keep pointer to first object
      C+A.A B=C.A			% B.A is address beyond string
					% error checks
      D0+5 A=DAT0.10 C=A.W		% to make the high nibbles equal
      LCASC(5) HPHP4 ?A#C.W EXIT	% exit if it doesn't start with HPHP4

      D0+16 C=DAT0.A CD0EX D=C.A	% skip HPHP4x-y, keep start of embedded object
      A=DAT0.A D0=C
      LC(5) PRLG ?A#C.A EXIT		% exit if object doesn't have a valid prologue

      GOSBVL =SAFESKIPOB }{ EXITC	% skip the embedded object, exit when not valid

      C=D.A CD0EX ?C>B.A EXIT		% exit if embedded object too large to fit inside
					% no errors, go ahead with shuffle
      ST=0.15				% disable interrupts
      D=C-D.A				% length of embedded object
      LC(5) DOLIST DAT1=C.A		% change type to list
      D1+5 C=D.A			% set up D1, C.A
      GOSBVL =MOVEDOWN			% shift embedded object left
      LC(5) DOHSTR DAT1=C.A		% write dummy object
      D1+10 AD1EX D1=A A=B-A.A		% calculate length
      D1-5 DAT1=A.A			% write length
      CD1EX C+A.A D1=C			% skip dummy
      LC(5) SEMI DAT1=C.A		% write list closing parenthesis
      GOSBVL =AllowIntr			% enable interrupts

      GOVLNG =GPOverWrR0Lp		% return pointer to embedded object
    }
    GOVLNG =GETPTRLOOP
  ENDCODE
  ZERO					% all other objects are simply returned
  NOP
;
@
